# rabbit-tools

工具链

## 安装步骤：

全局安装

```shell
npm install -g rabbit-tools
# or
yarn global add rabbit-tools
```

建议使用 npm 进行安装，这样会安装在特定的虚拟环境（如果使用nvm），而不是全局。

## 使用

1. 在项目根目录下，创建carrot.yml。
1. 填写对应的yml字段，commit可以通过执行 `rabbit` 自动填写。

yml文件配置说明

```yml
- name: repo
  repoPath: ../repo
  repoURL: 'git@github.com:person/repo.git'
  commit: aaaaa
```

| 字段 | 作用 |
| --- | --- |
| name | 依赖库的名字，在提示报错时，做显示用途 |
| repoPath | 依赖库的相对路径，相对当前yml文件 |
| repoURL | 依赖库的 git 地址 |
| commit | 依赖库的 `git commit id`  |

</details>

执行rabbit命令时，如果当前目录没有yml，会递归向上查找。查找到yml后，输出yml所在地址，并执行对应命令。

## API

使用 `rabbit --help` `rabbit [subcommand] --help` 进行查看

## 使用

根据yml文件配置说明，写好yml文件。

`rabbit clone` 自动会clone其他依赖文件库。

## 开发

```shell
ln -fs ./rabbit.js $(which rabbit)
```

## TODO

- [ ] 将 rabbit.js 更改为 ts，直接暴露 yargs。