"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var path = require("path");
var repoAction = require("./RepoAction");
var YmlLoader_1 = require("./YmlLoader");
var FileHandler_1 = require("./utils/FileHandler");
var chalk_1 = require("chalk");
var RepoLoader_1 = require("./RepoLoader");
/**
 * 依次从依赖树左侧节点读取内容，会导致后一个节点的子节点也覆盖顶层内容，需要用 flat 方法，重新操作内容。
 * @param repoDir yml 所在的目录
 * @param action 对 yml 依赖库所采取的操作, {config: 从 repoDir 中读取出来的依赖信息，repoDir：yml 文件所在的目录，与 repoDir 参数一致，options：部分 action 函数需要的额外参数，与 repoDir 一致}
 * @param options 部分操作的额外参数
 */
function recursiveAction(repoDir, action, options) {
    return __awaiter(this, void 0, void 0, function () {
        var dependencies, _i, dependencies_1, dependency, subDir, nestedRepos;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    dependencies = YmlLoader_1.loadYml(repoDir);
                    _i = 0, dependencies_1 = dependencies;
                    _a.label = 1;
                case 1:
                    if (!(_i < dependencies_1.length)) return [3 /*break*/, 5];
                    dependency = dependencies_1[_i];
                    subDir = path.resolve(repoDir, dependency.repoPath);
                    return [4 /*yield*/, action(dependency, repoDir, options)];
                case 2:
                    _a.sent();
                    nestedRepos = YmlLoader_1.loadYml(subDir);
                    if (!(nestedRepos.length > 0)) return [3 /*break*/, 4];
                    return [4 /*yield*/, recursiveAction(subDir, action, options)];
                case 3:
                    _a.sent();
                    _a.label = 4;
                case 4:
                    _i++;
                    return [3 /*break*/, 1];
                case 5: return [2 /*return*/];
            }
        });
    });
}
function clone(repoDir) {
    return __awaiter(this, void 0, void 0, function () {
        var flattedDependencies, _i, flattedDependencies_1, dependency;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, recursiveAction(repoDir, repoAction.clone)];
                case 1:
                    _a.sent();
                    flattedDependencies = RepoLoader_1.loadFlattedDep(repoDir);
                    _i = 0, flattedDependencies_1 = flattedDependencies;
                    _a.label = 2;
                case 2:
                    if (!(_i < flattedDependencies_1.length)) return [3 /*break*/, 5];
                    dependency = flattedDependencies_1[_i];
                    return [4 /*yield*/, repoAction.clone(dependency, dependency.parent)];
                case 3:
                    _a.sent();
                    _a.label = 4;
                case 4:
                    _i++;
                    return [3 /*break*/, 2];
                case 5: return [2 /*return*/];
            }
        });
    });
}
exports.clone = clone;
function pull(repoDir) {
    return __awaiter(this, void 0, void 0, function () {
        var flattedDependencies, _i, flattedDependencies_2, dependency;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, recursiveAction(repoDir, repoAction.pull)];
                case 1:
                    _a.sent();
                    flattedDependencies = RepoLoader_1.loadFlattedDep(repoDir);
                    _i = 0, flattedDependencies_2 = flattedDependencies;
                    _a.label = 2;
                case 2:
                    if (!(_i < flattedDependencies_2.length)) return [3 /*break*/, 5];
                    dependency = flattedDependencies_2[_i];
                    return [4 /*yield*/, repoAction.pull(dependency, dependency.parent)];
                case 3:
                    _a.sent();
                    _a.label = 4;
                case 4:
                    _i++;
                    return [3 /*break*/, 2];
                case 5: return [2 /*return*/];
            }
        });
    });
}
exports.pull = pull;
function checkout(repoDir) {
    return __awaiter(this, void 0, void 0, function () {
        var flattedDependencies, _i, flattedDependencies_3, dependency;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    flattedDependencies = RepoLoader_1.loadFlattedDep(repoDir);
                    _i = 0, flattedDependencies_3 = flattedDependencies;
                    _a.label = 1;
                case 1:
                    if (!(_i < flattedDependencies_3.length)) return [3 /*break*/, 4];
                    dependency = flattedDependencies_3[_i];
                    return [4 /*yield*/, repoAction.checkout(dependency, dependency.parent)];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3:
                    _i++;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/];
            }
        });
    });
}
exports.checkout = checkout;
function checkCommit(repoDir) {
    return __awaiter(this, void 0, void 0, function () {
        var flattedDependencies, _i, flattedDependencies_4, dependency;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    flattedDependencies = RepoLoader_1.loadFlattedDep(repoDir);
                    _i = 0, flattedDependencies_4 = flattedDependencies;
                    _a.label = 1;
                case 1:
                    if (!(_i < flattedDependencies_4.length)) return [3 /*break*/, 4];
                    dependency = flattedDependencies_4[_i];
                    return [4 /*yield*/, repoAction.checkCommit(dependency, dependency.parent)];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3:
                    _i++;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/];
            }
        });
    });
}
exports.checkCommit = checkCommit;
function state(repoDir) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, recursiveAction(repoDir, repoAction.state)];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports.state = state;
function update(repoDir, repo) {
    return __awaiter(this, void 0, void 0, function () {
        var repos, oldCommits, p, promiseMap, diff, str;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    repos = YmlLoader_1.loadYml(repoDir);
                    oldCommits = repos.map(function (c) { return c.commit; });
                    p = function (config) { return __awaiter(_this, void 0, void 0, function () {
                        var subRepo;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, repoAction.update(config, repoDir)];
                                case 1:
                                    _a.sent();
                                    subRepo = path.resolve(repoDir, config.repoPath);
                                    return [4 /*yield*/, update(subRepo)];
                                case 2:
                                    _a.sent();
                                    return [2 /*return*/];
                            }
                        });
                    }); };
                    promiseMap = repos.filter(function (v) { return v.name === repo || repo === undefined; }).map(function (v) { return p(v); });
                    return [4 /*yield*/, Promise.all(promiseMap)];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, checkModify(repoDir)];
                case 2:
                    _a.sent();
                    diff = repos.map(function (config, i) {
                        return __assign({}, config, { old: oldCommits[i] });
                    }).filter(function (config) {
                        return config.commit !== config.old;
                    }).map(function (config) {
                        return "repo:" + config.name + " in " + FileHandler_1.relativePath(repoDir) + " yml will change commit from " + chalk_1.default.green(config.old ? config.old : "no commit") + " to new commit " + chalk_1.default.green(config.commit);
                    });
                    if (diff.length !== 0) {
                        str = diff.reduce(function (v) { return "\n" + v; });
                        console.log(FileHandler_1.relativePath(repoDir) + " yml will update\n" + str);
                        YmlLoader_1.writeYml(repoDir, repos);
                    }
                    return [2 /*return*/];
            }
        });
    });
}
exports.update = update;
function checkModify(repoDir) {
    return __awaiter(this, void 0, void 0, function () {
        var flattedDependencies, _i, flattedDependencies_5, dependency;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    flattedDependencies = RepoLoader_1.loadFlattedDep(repoDir);
                    _i = 0, flattedDependencies_5 = flattedDependencies;
                    _a.label = 1;
                case 1:
                    if (!(_i < flattedDependencies_5.length)) return [3 /*break*/, 4];
                    dependency = flattedDependencies_5[_i];
                    return [4 /*yield*/, repoAction.checkModify(dependency, dependency.parent)];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3:
                    _i++;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/];
            }
        });
    });
}
exports.checkModify = checkModify;
function stash(repoDir) {
    return __awaiter(this, void 0, void 0, function () {
        var flattedDependencies, _i, flattedDependencies_6, dependency;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    flattedDependencies = RepoLoader_1.loadFlattedDep(repoDir);
                    _i = 0, flattedDependencies_6 = flattedDependencies;
                    _a.label = 1;
                case 1:
                    if (!(_i < flattedDependencies_6.length)) return [3 /*break*/, 4];
                    dependency = flattedDependencies_6[_i];
                    return [4 /*yield*/, repoAction.stash(dependency, dependency.parent)];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3:
                    _i++;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/];
            }
        });
    });
}
exports.stash = stash;
function clean(repoDir, options) {
    return __awaiter(this, void 0, void 0, function () {
        var flattedDependencies, _i, flattedDependencies_7, dependency;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    flattedDependencies = RepoLoader_1.loadFlattedDep(repoDir);
                    _i = 0, flattedDependencies_7 = flattedDependencies;
                    _a.label = 1;
                case 1:
                    if (!(_i < flattedDependencies_7.length)) return [3 /*break*/, 4];
                    dependency = flattedDependencies_7[_i];
                    return [4 /*yield*/, repoAction.clean(dependency, dependency.parent, options)];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3:
                    _i++;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/];
            }
        });
    });
}
exports.clean = clean;
//# sourceMappingURL=Action.js.map