"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var path = require("path");
var FileHandler_1 = require("./utils/FileHandler");
var git = require("./utils/Git");
var chalk_1 = require("chalk");
function pull(config, dir) {
    return __awaiter(this, void 0, void 0, function () {
        var repoDir, repoState, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    repoDir = path.resolve(dir, config.repoPath);
                    return [4 /*yield*/, FileHandler_1.getPathState(repoDir)];
                case 1:
                    repoState = _b.sent();
                    _a = repoState;
                    switch (_a) {
                        case FileHandler_1.FileState.None: return [3 /*break*/, 2];
                        case FileHandler_1.FileState.Dir: return [3 /*break*/, 4];
                        case FileHandler_1.FileState.File: return [3 /*break*/, 6];
                    }
                    return [3 /*break*/, 6];
                case 2: return [4 /*yield*/, git.clone(path.resolve(repoDir, ".."), config.repoURL, path.parse(repoDir).base)];
                case 3:
                    _b.sent();
                    return [3 /*break*/, 7];
                case 4: return [4 /*yield*/, git.pull(dir, config.repoURL)];
                case 5:
                    _b.sent();
                    return [3 /*break*/, 7];
                case 6: throw new Error("pull: " + repoDir + " is " + repoState);
                case 7: return [2 /*return*/];
            }
        });
    });
}
exports.pull = pull;
function clone(config, dir) {
    return __awaiter(this, void 0, void 0, function () {
        var repoDir, repoState, _a, currentCommit;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    repoDir = path.resolve(dir, config.repoPath);
                    return [4 /*yield*/, FileHandler_1.getPathState(repoDir)];
                case 1:
                    repoState = _b.sent();
                    _a = repoState;
                    switch (_a) {
                        case FileHandler_1.FileState.None: return [3 /*break*/, 2];
                        case FileHandler_1.FileState.Dir: return [3 /*break*/, 6];
                        case FileHandler_1.FileState.File: return [3 /*break*/, 10];
                    }
                    return [3 /*break*/, 10];
                case 2: return [4 /*yield*/, git.clone(path.resolve(repoDir, ".."), config.repoURL, path.parse(config.repoPath).base)];
                case 3:
                    _b.sent();
                    if (!config.commit) return [3 /*break*/, 5];
                    return [4 /*yield*/, git.reset(repoDir, config.commit)];
                case 4:
                    _b.sent();
                    _b.label = 5;
                case 5: return [3 /*break*/, 11];
                case 6:
                    currentCommit = git.readCommit(repoDir, config.commit ? config.commit.length : undefined);
                    if (!(currentCommit == config.commit)) return [3 /*break*/, 7];
                    console.log(config.name + " in " + FileHandler_1.relativePath(repoDir) + " do not need do any thing");
                    return [3 /*break*/, 9];
                case 7:
                    console.log(config.name + " in " + path.basename(dir) + ":" + FileHandler_1.relativePath(repoDir) + " already exists, begin fetch from: " + config.repoURL + " and reset to " + chalk_1.default.green(config.commit));
                    return [4 /*yield*/, git.reset(repoDir, config.commit)];
                case 8:
                    _b.sent();
                    _b.label = 9;
                case 9: return [3 /*break*/, 11];
                case 10: throw new Error("clone: " + repoDir + " is " + repoState);
                case 11: return [2 /*return*/];
            }
        });
    });
}
exports.clone = clone;
function clean(config, dir, options) {
    return __awaiter(this, void 0, void 0, function () {
        var repoDir, repoState, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    repoDir = path.resolve(dir, config.repoPath);
                    return [4 /*yield*/, FileHandler_1.getPathState(repoDir)];
                case 1:
                    repoState = _b.sent();
                    _a = repoState;
                    switch (_a) {
                        case FileHandler_1.FileState.None: return [3 /*break*/, 2];
                        case FileHandler_1.FileState.Dir: return [3 /*break*/, 3];
                        case FileHandler_1.FileState.File: return [3 /*break*/, 5];
                    }
                    return [3 /*break*/, 5];
                case 2:
                    console.log("clean: no such directory: " + repoDir);
                    return [3 /*break*/, 6];
                case 3: return [4 /*yield*/, git.clean(dir, options)];
                case 4:
                    _b.sent();
                    return [3 /*break*/, 6];
                case 5: throw new Error("pull: " + repoDir + " is " + repoState);
                case 6: return [2 /*return*/];
            }
        });
    });
}
exports.clean = clean;
function checkModify(config, dir) {
    return __awaiter(this, void 0, void 0, function () {
        var repoDir, repoState, status, something;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    repoDir = path.resolve(dir, config.repoPath);
                    return [4 /*yield*/, FileHandler_1.getPathState(repoDir)];
                case 1:
                    repoState = _a.sent();
                    switch (repoState) {
                        case FileHandler_1.FileState.None:
                            console.log("checkModify: no such directory: " + repoDir);
                            break;
                        case FileHandler_1.FileState.Dir:
                            {
                                status = git.status(repoDir, "s");
                                if (status.length > 0) {
                                    something = git.status(repoDir);
                                    throw new Error("repo:" + config.name + " in " + FileHandler_1.relativePath(repoDir) + " yml: need something to resolve first:\n" + something);
                                }
                                break;
                            }
                        case FileHandler_1.FileState.File:
                        default:
                            throw new Error("checkModify: " + repoDir + " is " + repoState);
                    }
                    return [2 /*return*/];
            }
        });
    });
}
exports.checkModify = checkModify;
function checkout(config, dir) {
    return __awaiter(this, void 0, void 0, function () {
        var repoDir, repoState;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    repoDir = path.resolve(dir, config.repoPath);
                    if (!config.commit) {
                        throw new Error(repoDir + " has no commit config");
                    }
                    return [4 /*yield*/, FileHandler_1.getPathState(repoDir)];
                case 1:
                    repoState = _a.sent();
                    switch (repoState) {
                        case FileHandler_1.FileState.Dir:
                            {
                                git.checkout(repoDir, config.commit);
                                break;
                            }
                        case FileHandler_1.FileState.None:
                            throw new Error("checkout: no such directory: " + repoDir);
                        case FileHandler_1.FileState.File:
                        default:
                            throw new Error("checkout: " + repoDir + " is " + repoState);
                    }
                    return [2 /*return*/];
            }
        });
    });
}
exports.checkout = checkout;
function checkCommit(config, dir) {
    return __awaiter(this, void 0, void 0, function () {
        var repoDir, repoState, repoCommit;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    repoDir = path.resolve(dir, config.repoPath);
                    return [4 /*yield*/, FileHandler_1.getPathState(repoDir)];
                case 1:
                    repoState = _a.sent();
                    switch (repoState) {
                        case FileHandler_1.FileState.Dir:
                            {
                                repoCommit = git.readCommit(repoDir, config.commit ? config.commit.length : undefined);
                                if (repoCommit === config.commit) {
                                    console.log("repo: " + config.name + " in " + FileHandler_1.relativePath(repoDir) + "'s commit-id is " + repoCommit + " " + chalk_1.default.green("[match]") + " " + FileHandler_1.relativePath(dir) + "'s yml commit-id");
                                }
                                else {
                                    throw new Error("repo: " + config.name + " in " + FileHandler_1.relativePath(repoDir) + "'s commit-id is " + chalk_1.default.red(repoCommit) + " " + chalk_1.default.red("[mismatch]") + " " + FileHandler_1.relativePath(dir) + "'s yml commit-id which is " + config.commit);
                                }
                                break;
                            }
                        case FileHandler_1.FileState.None:
                            throw new Error("checkCommit: no such directory: " + repoDir);
                        case FileHandler_1.FileState.File:
                        default:
                            throw new Error("checkCommit: " + repoDir + " is " + repoState);
                    }
                    return [2 /*return*/];
            }
        });
    });
}
exports.checkCommit = checkCommit;
function state(config, dir) {
    return __awaiter(this, void 0, void 0, function () {
        var repoDir, repoState, repoCommit;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    repoDir = path.resolve(dir, config.repoPath);
                    return [4 /*yield*/, FileHandler_1.getPathState(repoDir)];
                case 1:
                    repoState = _a.sent();
                    switch (repoState) {
                        case FileHandler_1.FileState.Dir:
                            {
                                repoCommit = git.readCommit(repoDir, config.commit ? config.commit.length : undefined);
                                if (repoCommit === config.commit) {
                                    console.log("repo: " + config.name + " in " + FileHandler_1.relativePath(repoDir) + "'s commit-id is " + repoCommit + " " + chalk_1.default.green("[match]") + " " + FileHandler_1.relativePath(dir) + "'s yml commit-id");
                                }
                                else {
                                    console.log("repo: " + config.name + " in " + FileHandler_1.relativePath(repoDir) + "'s commit-id is " + chalk_1.default.red(repoCommit) + " " + chalk_1.default.red("[mismatch]") + " " + FileHandler_1.relativePath(dir) + "'s yml commit-id which is " + config.commit);
                                }
                                break;
                            }
                        case FileHandler_1.FileState.None:
                            throw new Error("state: no such directory: " + repoDir);
                        case FileHandler_1.FileState.File:
                        default:
                            throw new Error("state: " + repoDir + " is " + repoState);
                    }
                    return [2 /*return*/];
            }
        });
    });
}
exports.state = state;
function update(config, dir) {
    return __awaiter(this, void 0, void 0, function () {
        var repoDir, repoState;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    repoDir = path.resolve(dir, config.repoPath);
                    return [4 /*yield*/, FileHandler_1.getPathState(repoDir)];
                case 1:
                    repoState = _a.sent();
                    switch (repoState) {
                        case FileHandler_1.FileState.Dir:
                            {
                                config.commit = git.readCommit(repoDir, config.commit ? config.commit.length : undefined);
                                break;
                            }
                        case FileHandler_1.FileState.None:
                            throw new Error("update: no such directory: " + repoDir);
                        default:
                            throw new Error("state: " + repoDir + " is " + repoState);
                    }
                    return [2 /*return*/];
            }
        });
    });
}
exports.update = update;
function stash(config, dir) {
    return __awaiter(this, void 0, void 0, function () {
        var repoDir, repoState, _a, status;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    repoDir = path.resolve(dir, config.repoPath);
                    return [4 /*yield*/, FileHandler_1.getPathState(repoDir)];
                case 1:
                    repoState = _b.sent();
                    _a = repoState;
                    switch (_a) {
                        case FileHandler_1.FileState.Dir: return [3 /*break*/, 2];
                        case FileHandler_1.FileState.None: return [3 /*break*/, 5];
                    }
                    return [3 /*break*/, 6];
                case 2:
                    status = git.status(repoDir, "s");
                    if (!(status.length > 0)) return [3 /*break*/, 4];
                    console.log(chalk_1.default.green("status " + repoDir + ": will stash modify"));
                    return [4 /*yield*/, git.stash(repoDir)];
                case 3:
                    _b.sent();
                    _b.label = 4;
                case 4: return [3 /*break*/, 7];
                case 5:
                    console.log("stash: no such directory: " + repoDir);
                    _b.label = 6;
                case 6: throw new Error("state: " + repoDir + " is " + repoState);
                case 7: return [2 /*return*/];
            }
        });
    });
}
exports.stash = stash;
//# sourceMappingURL=RepoAction.js.map