"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
require("source-map-support/register");
var action = require("./Action");
var yml = require("./YmlLoader");
var chalk_1 = require("chalk");
var RepoLoader_1 = require("./RepoLoader");
function load(argv) {
    return __awaiter(this, void 0, void 0, function () {
        var ymlDir, ymlRepo;
        return __generator(this, function (_a) {
            try {
                ymlDir = yml.findYmlDir();
                ymlRepo = RepoLoader_1.loadRepo(ymlDir);
                console.log(ymlRepo);
            }
            catch (error) {
                if (argv.verbose) {
                    console.log(chalk_1.default.red(JSON.stringify(error)));
                }
                else {
                    console.log(chalk_1.default.red(error.message));
                }
                process.exit(1);
            }
            return [2 /*return*/];
        });
    });
}
exports.load = load;
function flatDep(argv) {
    try {
        var ymlDir = yml.findYmlDir();
        var ymlRepo = RepoLoader_1.loadRepo(ymlDir);
        var flat = RepoLoader_1.flatDependencies(ymlRepo);
        console.log(flat);
    }
    catch (error) {
        if (argv.verbose) {
            console.log(chalk_1.default.red(JSON.stringify(error)));
        }
        else {
            console.log(chalk_1.default.red(error.message));
        }
        process.exit(1);
    }
}
exports.flatDep = flatDep;
function clone(argv) {
    return __awaiter(this, void 0, void 0, function () {
        var ymlDir, error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 6, , 7]);
                    ymlDir = yml.findYmlDir();
                    if (!argv.hard) return [3 /*break*/, 2];
                    return [4 /*yield*/, stash(argv)];
                case 1:
                    _a.sent();
                    return [3 /*break*/, 4];
                case 2: return [4 /*yield*/, checkModify(__assign({}, argv, { path: ymlDir }))];
                case 3:
                    _a.sent();
                    _a.label = 4;
                case 4: return [4 /*yield*/, action.clone(ymlDir)];
                case 5:
                    _a.sent();
                    return [3 /*break*/, 7];
                case 6:
                    error_1 = _a.sent();
                    if (argv.verbose) {
                        console.log(chalk_1.default.red(JSON.stringify(error_1)));
                    }
                    else {
                        console.log(chalk_1.default.red(error_1.message));
                    }
                    process.exit(1);
                    return [3 /*break*/, 7];
                case 7: return [2 /*return*/];
            }
        });
    });
}
exports.clone = clone;
function checkout(argv) {
    return __awaiter(this, void 0, void 0, function () {
        var ymlDir, error_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 3, , 4]);
                    ymlDir = yml.findYmlDir();
                    return [4 /*yield*/, checkModify(__assign({}, argv, { path: ymlDir }))];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, action.checkout(ymlDir)];
                case 2:
                    _a.sent();
                    return [3 /*break*/, 4];
                case 3:
                    error_2 = _a.sent();
                    if (argv.verbose) {
                        console.log(chalk_1.default.red(JSON.stringify(error_2)));
                    }
                    else {
                        console.log(chalk_1.default.red(error_2.message));
                    }
                    process.exit(1);
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    });
}
exports.checkout = checkout;
function update(argv) {
    return __awaiter(this, void 0, void 0, function () {
        var ymlDir, error_3;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 3, , 4]);
                    ymlDir = yml.findYmlDir();
                    return [4 /*yield*/, checkModify(__assign({}, argv, { path: ymlDir }))];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, action.update(ymlDir, argv.repo)];
                case 2:
                    _a.sent();
                    return [3 /*break*/, 4];
                case 3:
                    error_3 = _a.sent();
                    if (argv.verbose) {
                        console.log(chalk_1.default.red(JSON.stringify(error_3)));
                    }
                    else {
                        console.log(chalk_1.default.red(error_3.message));
                    }
                    process.exit(1);
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    });
}
exports.update = update;
function pull(argv) {
    return __awaiter(this, void 0, void 0, function () {
        var ymlDir, error_4;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 3, , 4]);
                    ymlDir = yml.findYmlDir();
                    return [4 /*yield*/, checkModify(__assign({}, argv, { path: ymlDir }))];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, action.pull(ymlDir)];
                case 2:
                    _a.sent();
                    return [3 /*break*/, 4];
                case 3:
                    error_4 = _a.sent();
                    if (argv.verbose) {
                        console.log(chalk_1.default.red(JSON.stringify(error_4)));
                    }
                    else {
                        console.log(chalk_1.default.red(error_4.message));
                    }
                    process.exit(1);
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    });
}
exports.pull = pull;
function state(argv) {
    return __awaiter(this, void 0, void 0, function () {
        var ymlDir, error_5;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    ymlDir = yml.findYmlDir();
                    return [4 /*yield*/, action.state(ymlDir)];
                case 1:
                    _a.sent();
                    return [3 /*break*/, 3];
                case 2:
                    error_5 = _a.sent();
                    if (argv.verbose) {
                        console.log(chalk_1.default.red(JSON.stringify(error_5)));
                    }
                    else {
                        console.log(chalk_1.default.red(error_5.message));
                    }
                    process.exit(1);
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    });
}
exports.state = state;
function check(argv) {
    return __awaiter(this, void 0, void 0, function () {
        var ymlDir, error_6;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 3, , 4]);
                    ymlDir = yml.findYmlDir();
                    return [4 /*yield*/, checkModify(__assign({}, argv, { path: ymlDir }))];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, action.checkCommit(ymlDir)];
                case 2:
                    _a.sent();
                    console.log(chalk_1.default.green("all dependences pass"));
                    return [3 /*break*/, 4];
                case 3:
                    error_6 = _a.sent();
                    if (argv.verbose) {
                        console.log(chalk_1.default.red(JSON.stringify(error_6)));
                    }
                    else {
                        console.log(chalk_1.default.red(error_6.message));
                    }
                    process.exit(1);
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    });
}
exports.check = check;
function stash(argv) {
    return __awaiter(this, void 0, void 0, function () {
        var ymlDir, error_7;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    ymlDir = yml.findYmlDir();
                    return [4 /*yield*/, action.stash(ymlDir)];
                case 1:
                    _a.sent();
                    return [3 /*break*/, 3];
                case 2:
                    error_7 = _a.sent();
                    if (argv.verbose) {
                        console.log(chalk_1.default.red(JSON.stringify(error_7)));
                    }
                    else {
                        console.log(chalk_1.default.red(error_7.message));
                    }
                    process.exit(1);
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    });
}
exports.stash = stash;
function checkModify(argv) {
    return __awaiter(this, void 0, void 0, function () {
        var error_8;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, action.checkModify(argv.path)];
                case 1:
                    _a.sent();
                    return [3 /*break*/, 3];
                case 2:
                    error_8 = _a.sent();
                    if (argv.verbose) {
                        console.log(chalk_1.default.red(JSON.stringify(error_8)));
                    }
                    else {
                        console.log(chalk_1.default.red(error_8.message));
                    }
                    process.exit(1);
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    });
}
function clean(argv) {
    return __awaiter(this, void 0, void 0, function () {
        var verbose, repo, hard, resetOptions, ymlDir, error_9;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    verbose = argv.verbose, repo = argv.repo, hard = argv.hard, resetOptions = __rest(argv, ["verbose", "repo", "hard"]);
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    ymlDir = yml.findYmlDir();
                    return [4 /*yield*/, action.clean(ymlDir, resetOptions)];
                case 2:
                    _a.sent();
                    return [3 /*break*/, 4];
                case 3:
                    error_9 = _a.sent();
                    if (argv.verbose) {
                        console.log(chalk_1.default.red(JSON.stringify(error_9)));
                    }
                    else {
                        console.log(chalk_1.default.red(error_9.message));
                    }
                    process.exit(1);
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    });
}
exports.clean = clean;
//# sourceMappingURL=index.js.map