"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var path = require("path");
var fs = require("fs");
var child_process = require("child_process");
exports.WorkDir = child_process.execSync("pwd").toString().trim();
var FileState;
(function (FileState) {
    FileState["None"] = "none";
    FileState["Dir"] = "directory";
    FileState["File"] = "file";
})(FileState = exports.FileState || (exports.FileState = {}));
function relativePath(dir) {
    return path.normalize(path.relative(exports.WorkDir, dir));
}
exports.relativePath = relativePath;
/**
 * 不再检测 SymbolicLink，直接根据 path 读取最终内容；
 * 如果需要识别 SymbolicLink，应该使用 fs.lstatSync;
 * 当不存在内容时，statSync 会直接 throw error
 */
function getPathState(dir) {
    try {
        var stats = fs.statSync(dir);
        if (stats.isDirectory()) {
            return FileState.Dir;
        }
        else if (stats.isFile()) {
            return FileState.File;
        }
        else {
            return FileState.None;
        }
    }
    catch (error) {
        return FileState.None;
    }
}
exports.getPathState = getPathState;
//# sourceMappingURL=FileHandler.js.map