import * as child_process from "child_process";

export function execSyncInDir(dir: string, command: string) {
    return execSync(`cd ${dir} && ${command}`);
}

export function execSync(command: string) {
    return child_process.execSync(command).toString().trim();
}

export async function execInDir(dir: string, command: string): Promise<String> {
    return exec(`cd ${dir} && ${command}`);
}

export async function exec(command: string): Promise<String> {
    return new Promise<String>((resolve, reject) => {
        const cmd = child_process.exec(`${command}`, (err, stdout, stderr) => {
            if (err) {
                reject({ err, stderr });
            } else {
                resolve(stdout);
            }
        });
        cmd.stderr.on("data", data => {
            process.stdout.write(`${data}`);
        });
        cmd.stdout.on("data", data => {
            process.stdout.write(`${data}`);
        });
    });
}